program BC;


DEVICE = mega1284P;



CONST

  // BAUDRATE  = 38400;
  // ProcClock = 16384000;       {Hertz}
  // ((ProcClock+BAUDRATE*8)/(BAUDRATE*16)-1)
  // (((38400*8)+16384000)/(38400*16))-1) = ((307200+16384000)/614400)-1 =
  // (16998400/614400)-1 = 27-1 = 26
  UBRR_VAL : WORD = 26;

  XON  : Byte = $11;
  XOFF : Byte = $13;




{--------------------------------------------------------------}


var

{
UDR1, UBRR1H, UBRR1L, UCSR1C, UCSR1B, UCSR1A
UDR0, UBRR0H, UBRR0L, UCSR0C, UCSR0B, UCSR0A
TWAM, TWCR, TWDR, TWAR, TWSR, TWBR, 
ASSR, OCR2B, OCR2A, OCR2, 
TCNT2, TCCR2, TCCR2B, TCCR2A,
OCR1BH, OCR1BL, OCR1AH, OCR1AL,
ICR1H, ICR1L, 
TCNT1H, TCNT1L, TCCR1C, TCCR1B, TCCR1A
DIDR1, DIDR0,
ADMUX, ADCSRB, ADCSR, ADCSRA, ADCH, ADCL
PCMSK3, 
TIMSK2, TIMSK1, TIMSK0,
PCMSK2, PCMSK1, PCMSK0,
EICRA, PCICR, OSCCAL,
PRR, PRR0,
CLKPR, WDTCR, WDTCSR,
SREG, SPH, SPL, RAMPZ,
SPMCSR, SPMCR, MCUCR, MCUCSR, MCUSR, SMCR,
OCDR, ACSR, SPDR, SPDR0, SPSR, SPSR0, SPCR, SPCR0,
GPIOR2, GPIOR1, 
OCR0B, OCR0, OCR0A,
TCNT0, TCCR0B, TCCR0, TCCR0A,
GTCCR, 
EEARH, EEARL, EEDR, EECR,
GPIOR0,
EIMSK, EIFR, PCIFR,
TIFR2, TIFR1, TIFR0,
}

  PORTD, DDRD, PIND, PORTC, DDRC, PINC, 
  PORTB, DDRB, PINB, PORTA, DDRA, PINA : ByteConReg; 

  UBRR0H, UBRR0L, UCSR0C, UCSR0B, UCSR0A, UDR0 : ByteConVar;
  UBRR0 : WordConVar;


  RXC0[UCSR0A,7] : Bit;
  TXC0[UCSR0A,6] : Bit;
  UDRE0[UCSR0A,5] : Bit;



{
PB2 = /BCWCLR  A -> H / BC Wait Clear (Aktiv bei L)
PB3 = BCWA     A -> L / BC Wait (Aktiv bei H)
PB4 = /Z80WA   E -> H / Z80 Wait(Aktiv bei L)
}
  BCWCLR_A[PortB,2] : bit;
  BCWA_A  [PortB,3] : bit;
  Z80WA_E [PINB, 4] : bit;


{
PC0 = /M1      A -> H
PC1 = /MREQ    A -> H
PC2 = /IORQ    A -> H
PC3 = /RD      A -> H
PC4 = /WR      A -> H
PC5 = /RESET   A -> H
PC6 = /BUSRQ   A -> H
PC7 = /BUSAK   E <- X
}
  M1_A   [PortC,0] : bit;
  M1_E   [PINC, 0] : bit;
  M1_D   [DDRC, 0] : bit;

  MREQ_A [PortC,1] : bit;
  MREQ_E [PINC, 1] : bit;
  MREQ_D [DDRC, 1] : bit;

  IORQ_A [PortC,2] : bit;
  IORQ_E [PINC, 2] : bit;
  IORQ_D [DDRC, 2] : bit;

  RD_A   [PortC,3] : bit;
  RD_E   [PINC, 3] : bit;
  RD_D   [DDRC, 3] : bit;

  WR_A   [PortC,4] : bit;
  WR_E   [PINC, 4] : bit;
  WR_D   [DDRC, 4] : bit;

  RESET_A[PortC,5] : bit;
  RESET_E[PINC, 5] : bit;
  RESET_D[DDRC, 5] : bit;

  BUSRQ_A[PortC,6] : bit;
  BUSRQ_E[PINC, 6] : bit;
  BUSRQ_D[DDRC, 6] : bit;

  BUSAK_A[PortC,7] : bit;
  BUSAK_E[PINC, 7] : bit;
  BUSAK_D[DDRC, 7] : bit;

{
PD0 = RXD0 E <-
PD1 = TXD0 A ->
PD2 = /CSAE    A -> H
PD3 = /INCRQ   E <- X
PD4 = /Z80CALL E <- X
PD5 = /Z80AK   A -> H
PD6 = LED_GRUEN A -> L
PD7 = LED_ROT   A -> L
}

  RXD0_E [PIND, 0] : bit;
  TXD0_A [PortD,1] : bit;
  CSAE_A [PortD,2] : bit;
  INCRQ_E [PIND,3] : bit;
  Z80CALL_E[PIND,4]: bit;
  Z80AK_A[PortD,5] : bit;
  LED_GRUEN[PortD,6]: bit;
  LED_ROT[PortD,7] : bit;


  Zeichen : Byte;

  loop_in : Boolean;

CONST

  Loader : array[0..127] of Byte = (

 $F3,$3E,$03,$D3,$F9,$D3,$FB,$3E,$CF,$D3,$F9,$D3,$FB,$3E,$FF,$D3,	// 0000H
 $F9,$3E,$1F,$D3,$FB,$3E,$FF,$D3,$FA,$2E,$05,$0E,$00,$06,$00,$05,	// 0010H
 $20,$FD,$0D,$20,$F8,$2D,$20,$F3,$FE,$00,$28,$06,$3E,$00,$D3,$FA,	// 0020H
 $18,$E7,$3E,$FF,$D3,$FA,$18,$E1,$76,$00,$00,$00,$00,$00,$00,$00,	// 0030H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,	// 0040H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,	// 0050H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,	// 0060H
 $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	// 0070H

  );




{--------------------------------------------------------------}
{ functions }


procedure InitPorts;
begin
  // PORT A = Daten
  DDRA:=  %00000000;


{
PB0 = frei 
PB1 = frei

PB2 = /BCWCLR  A -> H / BC Wait Clear (Aktiv bei L)
PB3 = BCWA     A -> L / BC Wait (Aktiv bei H)
PB4 = /Z80WA   E -> H / Z80 Wait(Aktiv bei L)

PB5 = MOSI 
PB6 = MISO 
PB7 = SCK 
}
  // PORT B Voreinstellungen
  PORTB:= %00000100;

  //       EEEEAAEE
  DDRB:=  %00001100;

  // PORT B Voreinstellungen
  PORTB:= %00000100;

{
PC0 = /M1      A -> H
PC1 = /MREQ    A -> H
PC2 = /IORQ    A -> H
PC3 = /RD      A -> H
PC4 = /WR      A -> H
PC5 = /RESET   A -> H
PC6 = /BUSRQ   A -> H
PC7 = /BUSAK   E <- X
}

  // PORT C Voreinstellungen (BUSRQ ist aktiv)
  PORTC:= %00111111;

  //       EAAAAAAA
  DDRC:=  %01111111;

  // PORT C Voreinstellungen (BUSRQ ist aktiv)
  PORTC:= %00111111;

{
PD0 = RXD0      E <-
PD1 = TXD0      A ->
PD2 = /CSAE     A -> H
PD3 = /INCRQ    E <- X
PD4 = /Z80CALL  E <- X
PD5 = /Z80AK    A -> H
PD6 = LED_GRUEN A -> L
PD7 = LED_ROT   A -> L
}
  // PORT D Voreinstellungen
  PORTD:= %00100100;

  //       AAAEEAAE
  DDRD:=  %11000110;

  // PORT D Voreinstellungen
  PORTD:= %00100100;

end InitPorts;



// ******************************
// *** serielle Schnittstelle ***
// ******************************



procedure INIT_SER_PORT;
begin

{
 Initialisieren der seriellen Schnittstelle
 ---------------------------------------------

; festlegen der Baudrate fuer die serielle Schnittstelle
}

    UBRR0 := UBRR_VAL;

{
Bit 4 – RXEN: Receiver Enable
Bit 3 – TXEN: Transmitter Enable
}
    UCSR0B := %00011000;

{
URSEL UMSEL UPM1 UPM0 USBS UCSZ1 UCSZ0 UCPOL
    1     0    0    0    0     1     1     0
}
    UCSR0C := %10000110;


end INIT_SER_PORT;




procedure sende_Zeichen(s_Zeichen : Byte);
begin
  // wenn UDRE0 gesetzt ist, so ist der Puffer leer
  // -> warten solange UDRE0 = 0  
  while BitLow(UDRE0) do
    SetBit(LED_GRUEN); // gruen ein
  endwhile;

  ClearBit(LED_GRUEN); // gruen aus

  UDR0:=s_Zeichen;

end sende_Zeichen; 



procedure sende_HEX_Zeichen(h_Zeichen : Byte);
var
  HexLow : Byte;
  HexHigh : Byte;

begin


  HexHigh:=h_Zeichen and $F0;
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  SHR(HexHigh);
  if HexHigh>9 then
    HexHigh:=HexHigh+55;
  else
    HexHigh:=HexHigh+48;
  endif;

  sende_Zeichen(HexHigh); 


  HexLow:=h_Zeichen and $0F;
  if HexLow>9 then
    HexLow:=HexLow+55;
  else
    HexLow:=HexLow+48;
  endif;

  sende_Zeichen(HexLow);


end sende_HEX_Zeichen;



procedure RX_Puffer_abfragen;
begin
  // wurde ein Byte durch die UART empfangen, so ist das RXC0-Bit gesetzt 
  // ist RXC0-Bit = 0, dann ist der Empfangs-Puffer leer
  if BitHigh(RXC0) then
    Zeichen:=UDR0;
  else  
    Zeichen:=0;
  endif; { if BitHigh(RXC0) then }
end RX_Puffer_abfragen;





// ******************************
// ***    Hilfssprogramme     ***
// ******************************




PROCEDURE wait_ms(Zeit : Word);
VAR
  w1 : Word;
  w2 : Word;
BEGIN
  for w1:=1 to Zeit do
    for w2:=1 to 720 do // 45 * MHz
    endfor;
  endfor;
END wait_ms;




// ******************************
// ***  Auswertungsprogramme  ***
// ******************************





// Betriebsart Programmieren mit Inkrement
procedure AE_WRITE_BYTE(WR_Byte : byte);
begin

  // warten bis ATMEGA162 bereit ist
  while BitLow(INCRQ_E) do
  endwhile;

  // /WR aktiv schalten
  ClearBit(WR_A);    // WE_A aktiv

  // Datenbus auf Ausgang
  DDRA:= %11111111; // D0-D7 A

  // Daten auf Datenbus legen
  PORTA:=WR_Byte;

  NOP;

  // CSAE_A aktiv schalten (Daten koennen uebernommen werden)
  ClearBit(CSAE_A);

  // warten bis Daten uebernommen wurden
  while BitHigh(INCRQ_E) do
  endwhile;

  // Betriebsart Programmieren abschalten
  SetBit(CSAE_A);  // CSAE_A inaktiv

  // Uebertragung abgeschlossen

  DDRA:= %00000000; // Datenbus auf Eingang
  
  SetBit(WR_A);    // WR_A inaktiv

end AE_WRITE_BYTE; 







procedure COPY_ARRAY_TO_RAM;
var
  READ_DATA : Byte;
  Adresse : Word;
begin

  SetBit(LED_ROT);

  // adr_00_07
  AE_WRITE_BYTE(0);

  // adr_08_15
  AE_WRITE_BYTE(0);

  // adr_16_18
  AE_WRITE_BYTE(0);

  // Chips inaktiv schalten
  SetBit(RD_A);
  SetBit(WR_A);
  SetBit(MREQ_A);
  SetBit(CSAE_A);

  Adresse:=0;

  loop_in := false;

  DDRA := %11111111; // Daten alles Ausgänge

   
  for Adresse:=0 to 127 do

    if loop_in then
      // warten falls Adress-Decoder noch beschaeftigt ist (unwahrscheinlich)
      while BitHigh(INCRQ_E) do
      endwhile;
    else
      loop_in := true;
    endif;

    // jetzt Adressdecoder inaktivieren
    SetBit(CSAE_A);

    // Daten lesen von ARRAY
    READ_DATA:=Loader[Adresse];


    // Daten schreiben in RAM
    PortA := READ_DATA; // Data

    ClearBit(MREQ_A);
    ClearBit(WR_A); 
 
 

    NOP; 
    NOP;  
    NOP; 
    NOP;  

    SetBit(MREQ_A);
    SetBit(WR_A);
 
    
    // naechste Adresse anlegen durch Adress-Decoder
    while BitLow(INCRQ_E) do
    endwhile;

    ClearBit(CSAE_A);  // CSAE_A aktiv
   
  endfor; 

  DDRA :=  %00000000; // alles Eingänge


  // warten falls Adress-Decoder noch beschaeftigt ist (unwahrscheinlich)
  while BitHigh(INCRQ_E) do
  endwhile;

  // jetzt Adressdecoder inaktivieren
  SetBit(CSAE_A);  // CSAE_A inaktiv
  SetBit(WR_A);    // WE_A inaktiv
  SetBit(RD_A);    // OE_A inaktiv

  // warten bis Adress-Decoder bereit ist
  while BitLow(INCRQ_E) do
  endwhile;

  ClearBit(LED_ROT);

end COPY_ARRAY_TO_RAM;




procedure setze_ADRESSE;
begin

  // adr_00_07
  AE_WRITE_BYTE(0);

  // adr_08_15
  AE_WRITE_BYTE(0);

  // adr_16_18
  AE_WRITE_BYTE(0);

end setze_ADRESSE;





procedure READ_RAM;
var
  READ_DATA : Byte;

begin

  SetBit(LED_ROT);

  DDRA :=  %00000000; // alles Eingänge

  // Chips inaktiv schalten
  SetBit(RD_A);
  SetBit(WR_A);
  SetBit(CSAE_A);

  ClearBit(MREQ_A);
  ClearBit(RD_A);  

  NOP; 
  NOP;  
  NOP; 
  NOP;  

  READ_DATA:=PINA;

  SetBit(RD_A);
  SetBit(MREQ_A);

  ClearBit(CSAE_A);  // CSAE_A aktiv

  sende_HEX_Zeichen(READ_DATA);
 
  // naechste Adresse anlegen durch Adress-Decoder
  while BitHigh(INCRQ_E) do
  endwhile;

  SetBit(CSAE_A);  // CSAE_A inaktiv

  ClearBit(LED_ROT);

end READ_RAM;






procedure starte_Z80;
begin

  // als Erstes ziehen wir uns schrittweise zurueck

  // PORT A = Daten
  DDRA:=  %00000000;





end starte_Z80;









procedure Zeichen_auswerten;
begin

  case Zeichen of

    $61 : COPY_ARRAY_TO_RAM;
          sende_Zeichen($41); // a -> A 

    |

    $62 : setze_ADRESSE;
          sende_Zeichen($42); // b -> B 

    |

    $63 : READ_RAM;
          sende_Zeichen($43); // c -> C 

    |

    $64 : starte_Z80;
          sende_Zeichen($44); // d -> D 

    |



  else
    sende_Zeichen($58); // -> X
  endcase;

  Zeichen:=0;

end Zeichen_auswerten;









// ******************************
// *** serielle Schnittstelle ***
// ******************************







{--------------------------------------------------------------}
{ Main Program }
{$IDATA}







begin

ASM;

.equ UBRR0 = UBRR0L

ENDASM;

  // Grundeinstellung der Ports
  InitPorts;

  INIT_SER_PORT;

  ClearBit(LED_GRUEN);  // LED_GRUEN aus
  ClearBit(LED_ROT);  // LED_ROT aus


  // Ruecksetzen der WAIT-Logik
  ClearBit(BCWA_A);






  loop

    RX_Puffer_abfragen;

    if Zeichen>0 then
      Zeichen_auswerten;
    endif;

  endloop;


end BC.


